var headerHeight = 48;
var HOST = "http://ljzdj.ikinvin.net/";
var commonUrl = HOST + "/api.php?";
var ENCRYPT_TOKEN  = 'zmjjw20160722';
var APPNAME = '刘集镇';
var VERSION = '1.0.0';

var STORAGE_KEY 	= ['plum_session', 'plum_nickname','plum_mobile', 'plum_avatar'];
var LOC_UPDATE_FREQ = 10*60;//位置更新频率，10分钟
var LOCATION_KEY	= ['plum_province', 'plum_city', 'plum_zone'];
var LOCATION = {
	'latitude' : 0,
	'longitude' : 0,
	'timestamp' : 0
};
var WXSHARE = {
	'friend' : 'session',
	'timeline' : 'timeline',
	'favorite' : 'favorite'
};
var SHARE_STRUCT = {
	'title' 	: '',
	'content'	: '',
	'imgPath'	: '',
	'url'		: ''
};
/**
 * ajax请求封装
 * @param {Object} url
 * @param {Object} param
 * @param {Object} callBackDone
 * @param {Object} callBackAlways
 */
function plumAjax(url, param, callBackDone, callBackAlways, callBackFail) {
	var user = plumGetUser();
	var loginLink = user.plum_user ? '&plum_session_api='+user.plum_session : '&plum_session_api=2016vmidu2ct8pid1gshaj8vu0';
	$.ajax({
		url : commonUrl + url+'&version='+VERSION+loginLink,
		data : param,
		dataType : 'json',
		method : "POST",
		cache : false,
		timeout : 20000//毫秒单位
	}).done(function(ret) {
		callBackDone(ret);
	}).always(function() {
		if ( typeof callBackAlways != "undefined")
			callBackAlways();
	}).fail(function() {
		if ( typeof callBackFail != "undefined")
			callBackFail();
	});
}

/*
 * 网络请求错误时的页面提示
 * @param boolean frame 默认为true，加载错误页面提示
 */
function plumNetworkFail(frame, winName, frameName) {
	frame = frame ? true : false;
	var msg;
	if (api.connectionType == "none") {
		msg = '网络连接失败，请检查网络设置';
	} else {
		msg = '服务器连接失败，请重试';
	}
	if (frame) {
		var extra = {
			'winName' : winName,
			'frmName' : frameName
		};
		api.openWin({
			name : 'frame-no-network',
			url : './frame-no-network.html',
			pageParam : {
				extra : extra
			},
			animation : {
				type : "none"
			}
		});
	}

	api.toast({
		msg : msg,
		duration : 2000,
		location : 'bottom'
	});
}

function plumSetUser(info) {
	for (var x in STORAGE_KEY) {
//		var value	= (STORAGE_KEY[x] in info) && info[STORAGE_KEY[x]] ? info[STORAGE_KEY[x]] : null;
//		$api.setStorage(STORAGE_KEY[x], value);
        if(STORAGE_KEY[x] in info){
            $api.setStorage(STORAGE_KEY[x], info[STORAGE_KEY[x]]);
        } 
	}
}

function plumGetUser() {
	var session = $api.getStorage('plum_session');
	var ret	= {'plum_user' : session ? true : false};
	for (var x in STORAGE_KEY) {
		ret[STORAGE_KEY[x]]		= $api.getStorage(STORAGE_KEY[x]);
	}
	return ret;
}

function plumNeedLogin(path, title, extra) {
	var user = plumGetUser();
	var extra = extra ? extra : {};
	if (!user.plum_user) {
		path = 'login';
		title = '登录';
	}
	plumOpenCommonWin(path, title, extra);
}
/**
 *检查是否登录，未登录则跳到登录页面，登录了，则无反应 
 */
function checkHasLogin(){
	var user = plumGetUser();
	if (!user.plum_user) {
		plumOpenCommonWin('login', '登录', {})
	}
}
/**
 * 清除用户登录的缓存信息 
 */
function plumRmUser() {
	for (var x in STORAGE_KEY) {
		$api.rmStorage(STORAGE_KEY[x]);
	}
}

/**
 * 手机号正则验证
 * @param {Object} phone
 */
function plumIsPhone(phone) {
	var pattern = /1\d{10}/;

	return pattern.test(phone);
}

function plumIsChinese(word) {
	var pattern = /[\u4e00-\u9fa5]/;

	return pattern.test(word);
}

function plumIsNumber(number, type) {
	type = type ? type : 'int';

	return !isNaN(number);
}

function plumIsCode(code) {
	var pattern = /\d{4}|\d{6}/;

	return pattern.test(code);
}

/**
 * 密码长度校验
 * @param {Object} pass
 * @param {Object} min
 * @param {Object} max
 */
function plumPassCheck(pass, min, max) {
	min = min ? min : 6;
	max = max ? max : 30;

	return (pass.length >= min) && (pass.length <= max);
}
/**
 * 打开通用的window页面 
 */
function plumOpenCommonWin(path, title, extra) {
	extra = extra || {};
	var url = api.winName == 'root' && !api.frameName ? './html/win-common.html' : './win-common.html';

	var win_name	= ("useWinName" in extra) && extra["useWinName"] ? extra["useWinName"] : 'win-' + path + '-header';
	//是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只iOS有效
	var slid_back = ("back" in extra) ? extra["back"] : true;
	delete extra.slidBackEnabled;
	api.openWin({
		name : win_name,
		url : url,
		pageParam : {
			path : path,
			title : title,
			extra : extra
		},
		slidBackEnabled : slid_back
	});
}

function plumOpenHeader(type, path, title, extra) {
	extra = extra ? extra : {};
	type = type && type == 'common' ? 'common' : 'custom';

	if (type == 'common') {
		plumOpenCommonWin(path, title, extra);
	} else {
		var url = './win-' + path + '-header.html';
		api.openWin({
			name : 'win-' + path,
			url : url,
			pageParam : {
				title : title,
				path : path,
				extra : extra
			}
		});
	}
}

/*
 * 从相机或图片库选择图片，回调中请求图片路径
 */
function plumSelectImage(callback) {
	//图片选择提示
	api.actionSheet({
		cancelTitle : "取消",
		buttons : ["拍照", "从相册选取"]
	}, function(ret, err) {
		if (3 == ret.buttonIndex) {// 用户取消.
			return;
		}
		var sourceType = "library";
		if (1 == ret.buttonIndex) {/* 打开相机*/
			sourceType = "camera";
		}

		api.getPicture({
			sourceType : sourceType,
			encodingType : "jpg",
			mediaValue : "pic",
			allowEdit : true,
			quality : 70, //图片质量
			targetWidth : 800, //图片宽度比例
			saveToPhotoAlbum : false
		}, function(ret, err) {
			if (ret && ret.data) {
				callback(ret.data);
			}
		});
	});
}
/**
 * 开始导航 
 */
function plumStartNav(point) {
	api.actionSheet({
		cancelTitle : "取消",
		buttons : ["百度地图", "高德地图"]
	}, function(ret, err) {
		if (3 == ret.buttonIndex) {// 用户取消.
			return;
		}
		var params, bundleName, packageName;
		if (1 == ret.buttonIndex) {/* 百度地图*/
			bundleName	= 'baidumap://';
			packageName = 'com.baidu.BaiduMap';
			params	= {
				iosUrl : 'baidumap://map/direction',
				appParam : {
					origin : point['ori']['lat']+','+point['ori']['lon'],
					destination: point['des']['lat']+','+point['des']['lon'],
					mode : 'driving',
					src : APPNAME
				},
				androidPkg : 'com.baidu.BaiduMap',
				uri : 'bdapp://map/direction?origin='+point['ori']['lat']+','+point['ori']['lon']+'&destination='+point['des']['lat']+','+point['des']['lon']+'&mode=driving&src=天点|'+APPNAME
			};
		} else if (2 == ret.buttonIndex) {/* 高德地图 */
			bundleName	= 'iosamap://';
			packageName = 'com.autonavi.minimap';
			params	= {
				iosUrl : 'iosamap://navi',
				appParam : {
					sourceApplication : APPNAME,
					lat : point['des']['lat'],
					lon : point['des']['lon'],
					dev : 0,
					style : 2
				},
				androidPkg : 'com.autonavi.minimap',
				uri: 'androidamap://route?sourceApplication='+APPNAME+'&slat='+point['ori']['lat']+'&slon='+point['ori']['lon']+'&sname=我的位置&dlat='+point['des']['lat']+'&dlon='+point['des']['lon']+'&dname=商家位置&dev=0&m=0&t=2'
			};
		}
		if (api.systemType == 'ios') {
			api.appInstalled({
				appBundle : bundleName
			}, function (ret) {
				if (ret.installed) {
					api.openApp(params, function(ret,err){ 
					});
				} else {
					api.toast({
	                    msg:'应用未安装'
                    });
				}
			});
		} else {
			api.appInstalled({
				appBundle : packageName
			}, function (ret) {
				if (ret.installed) {
					window.location.href=params.uri;
				} else {
					api.toast({
	                    msg:'应用未安装'
                    });
				}
			});
		}
	});
}

/*
 * 单张图片上传
 */
function plumUploadImage(path, callback) {
	api.ajax({
		url : commonUrl + 'map=api_index_img_upload',
		method : 'post',
		timeout : 30,
		dataType : 'json',
		data : {
			files : {
				image : path
			}
		}
	}, function(ret, err) {
		if (ret && ret.ec == 200) {
			callback(ret.data.path);
		} else {
			plumNetworkFail(false);
		}
	});
}

/**********************************信鸽推送相关逻辑开始**************************************/
/**
 * 信鸽推送账号注册，设置推送标签
 * @param account 绑定账号id到当前设备
 */
function plumXGRegister(account) {
	//设置account为字符串类型，另外account为空表示只注册设备不绑定账号
	var params = account ? {account : ''+account+''} : {account : ''};
	// 注册设备
	var tencentPush = api.require('tencentPush');

	tencentPush.registerPush(params, function(ret, err) {
		alert(JSON.stringify(ret));
		if (ret.status) {
			
		} else {
			//信鸽推送注册失败
		}
	});
}

/*
 * 信鸽设置推送标签
 */
function plumXGSetTag(tag) {
	//设置推送标签
	if (tag) {
		var tencentPush = api.require('tencentPush');
		tencentPush.setTag({tag : tag}, function(ret, errs) {
			if (ret.status) {
				//alert("标签设置成功，标签名："+ret.tag);
			} else {
				//alert("标签设置失败，错误码："+err.code+"，错误信息："+err.msg);
			}
		});
	}
}

/*
 * 信鸽删除推送标签
 */
function plumXGDelTag(tag) {
	//设置推送标签
	if (tag) {
		var tencentPush = api.require('tencentPush');
		tencentPush.delTag({tag : tag}, function(ret, errs) {
			if (ret.status) {
				//alert("标签删除成功，标签名："+ret.tag);
			} else {
				//alert("标签删除失败，错误码："+err.code+"，错误信息："+err.msg);
			}
		});
	}
}

/*
 * 信鸽推送解除账号与设备的绑定关系
 */
function plumXGRmRegister() {
	var params = {account : "*"};
	// 注册设备
	var tencentPush = api.require('tencentPush');

	tencentPush.registerPush(params, function(ret, err) {
		if (ret.status) {
			//alert("注册成功，token为：" + ret.token);
		} else {
			//alert("注册失败，错误码：" + err.code + "，错误信息：" + err.msg);
		}
	});
}

/**
 * 将设备从注册信息表中删除，不再接收任何推送 
 */
function plumXGUnRegister() {
	// 反注册
	var tencentPush = api.require('tencentPush');

	tencentPush.unregisterPush(function(ret, err) {
		if (ret.status) {
			//alert("注册成功，token为：" + ret.token);
		} else {
			//alert("注册失败，错误码：" + err.code + "，错误信息：" + err.msg);
		}
	});
}
/**********************************信鸽推送相关逻辑结束**************************************/
/*
 * 开始定位，跨平台，使用百度定位模块
 */
function plumStartLocation() {
	var bMap = api.require('bMap');
	bMap.getLocation({
	    accuracy: '100m',
	    autoStop: true,
	    filter: 1
	}, function(ret, err) {
	    if (ret.status) {
	        //获取定位信息后存储
			$api.setStorage('plum_curr_lat', ret.lat);
			$api.setStorage('plum_curr_lng', ret.lon);
			$api.setStorage('plum_curr_time', ret.timestamp);
	    } else {
	        api.toast({
	            msg:'定位未被允许',
	            location: 'bottom'
            });
	    }
	});
}

function getAreaByLonLat(){
	var map = api.require('bMap');
	map.getNameFromCoords({
	    lon: 116.384767,
	    lat: 39.989539
	}, function(ret, err) {
		alert(JSON.stringify(ret));
	    if (ret.status) {
	        alert(JSON.stringify(ret));
	    }else{
	    		alert(JSON.stringify(err));
	    }
	});
}

/**
 * 获取定位信息
 */
function plumGetLocation(callback) {
	var bMap 		= api.require('bMap');
	var last_time 	= $api.getStorage('plum_curr_time');
	if (last_time && last_time > ((new Date()).getTime()+10*60*1000)) {
		//有效时间内，不做更新
		if (callback) {
			callback(bMap, {'lat' : $api.getStorage('plum_curr_lat'), 'lon' : $api.getStorage('plum_curr_lng')});
		}
	} else {
		bMap.getLocation(function(ret, err) {
			if (!ret.status) {
				api.toast({
		            msg:'获取定位失败',
		            location: 'bottom'
	            });
			} else {
				//获取定位信息后存储
				$api.setStorage('plum_curr_lat', ret.lat);
				$api.setStorage('plum_curr_lng', ret.lon);
				$api.setStorage('plum_curr_time', ret.timestamp);
			}
			if (callback) {
				callback(bMap, {'lat' : $api.getStorage('plum_curr_lat'), 'lon' : $api.getStorage('plum_curr_lng')});
			}
		});
	}
}

function plumRCConnect(token, callback) {
	var rong = api.require('rongCloud2');

	rong.connect({
		token : token
	}, function(ret, err) {
		if (callback && ret.status == 'success') {
			callback();
		}
	});
}

function plumOpenRCChat(target) {
	var path = 'chat';
	var title = '消息';
	var extra = {
		target : target,
		chat : true
	};
	var user = plumGetUser();
	if (user.plum_user) {
		plumSetChatUid(target.uid);
	}
	plumNeedLogin(path, title, extra);
}

/*
 * 设置当前正在会话的用户ID
 */
function plumSetChatUid(uid) {
	uid = uid ? uid : 0;
	$api.setStorage('chatuid', uid);
}

/*
 * 获取当前正在会话的用户ID
 */
function plumGetChatUid() {
	var uid = $api.getStorage('chatuid');
	uid = uid ? uid : 0;
	return uid;
}
/*
 * 写入缓存文件
 */
function plumWriteCacheFile(filename, json, append) {
	var append = append ? append : false;
	var json = typeof json == "object" ? JSON.stringify(json) : json;
	api.writeFile({
	    path:'cache://json/'+filename+'.json',
	    data:json,
	    append: append
    },function(ret,err){
    	//coding...
    });
}
/*
 * 读取缓存文件
 */
function plumReadCacheFile(filename, callback) {
	api.readFile({
	    path:'cache://json/'+filename+'.json'
    },function(ret,err){
    	if (ret.status) {
    		callback(JSON.parse(ret.data));
    	}
    });
}

/**
 *数据渲染到模版上 
 */
function plumTemplate(contId,tplId,data){
	var content = $('#'+contId);
	var tpl 	= $('#'+tplId).text();
	var tempFn 	= doT.template(tpl);
	content.append(tempFn(data));
}
/**
 *展示缓存数据 
 */
function showCacheData(filename,contentId,tplId){
	plumReadCacheFile(filename, function(data) {
			var content = $('#'+contentId);
			var tpl = $('#'+tplId).text();
			var tempFn = doT.template(tpl);
			content.append(tempFn(data));
			api.parseTapmode();
			//设置查找分类
			initKindlist();
		});
}

function plumInitShare() {
	var model = $('#model');
	var share = $('#share');

	var status = model.attr('data-status');

	if (status == 'show') {
		model.hide();
		share.hide();
		model.attr('data-status', 'hide');
	} else {
		model.show();
		share.show();
		model.attr('data-status', 'show');
	}
}

function plumShareTo(type, struct) {
	switch(type) {
		case 'friend' :

		case 'timeline' :
			api.toast({
				msg : '发起到微信的分享中...',
				duration : 3000,
				location : 'bottom'
			});
			plumWxWebShare(type, struct);
			break;
		case 'QFriend' :

		case 'QZone' :
			api.toast({
				msg : '发起到QQ的分享中...',
				duration : 3000,
				location : 'bottom'
			});
			plumQqWebShare(type, struct);
			break;
		case 'weibo' :
			api.toast({
				msg : '发起到新浪微博的分享中...',
				duration : 3000,
				location : 'bottom'
			});
			plumSinaWeiboWebShare(struct);
			break;
		case 'copy' :
			plumClipBoard(struct.url);
			break;
	}
}
/*
 * 分享到微信
 */
function plumWxWebShare(type, struct) {
	var wx = api.require('wx');
	wx.isInstalled(function(ret, err) {
		if (ret.installed) {
			wx.shareWebpage({
				scene : WXSHARE[type],
				title : struct.title,
				description : struct.content,
				thumb : struct.imgPath,
				contentUrl : struct.url
			}, function(ret, err) {
				
			});
		} else {
			api.alert({
				title : '提示',
				msg : '当前设备未安装微信客户端'
			});
		}
	});
}
/*
 * 分享到QQ
 */
function plumQqWebShare(type, struct) {
	var qq = api.require('qq');
	qq.installed(function(ret, err) {
		if (ret.status) {
			qq.shareNews({
				url : struct.url,
				title : struct.title,
				description : struct.content,
				imgUrl : struct.imgPath,
				type : type
			}, function(ret, err) {
				//分享后的回调
			});
		} else {
			api.alert({
				title : '提示',
				msg : '当前设备未安装QQ客户端'
			});
		}
	});
}
/*
 * 分享到新浪微博
 */
function plumSinaWeiboWebShare(struct) {
	var weibo = api.require('weibo');
	weibo.shareWebPage({
		text : struct.content,
		title : struct.title,
		description : struct.content,
		thumb : struct.imgPath,
		contentUrl : struct.url
	}, function(ret, err) {
		if (ret.status) {

		}
	});
}
/*
 * 复制到剪切板
 */
function plumClipBoard(url) {
	var obj = api.require('clipBoard');
	obj.set({
		value : url
	}, function(ret, err) {
		var msg = '复制到剪切板失败';
		if (ret.status) {
			msg = '复制到剪切板成功';
		}
		api.toast({
			msg : msg,
			duration : 3000,
			location : 'bottom'
		});
	});
}
/**
 * 网页加载进度等待弹窗 
 */
function plumPageLoad() {
	api.showProgress({
		style : 'default',
		animationType : 'fade',
		title : '加载中',
		text : '请稍候',
		modal : false
	});
	loadShowHide(true);
}

function loadShowHide(type,msg) {
	var type = type ? true : false;
	var load = $('#loading');

	if (type) {
		load.show();
	} else {
		load.hide();
		$('div.loadResult').html(msg);
	}
}
/*
 * 欲加密数据组成的数组
 */
function plumEncryptCheck(arr) {
	//转换为字符串，并添加token
	for (var x in arr) {
		console.log(typeof arr[x]);
		if (typeof arr[x] != 'string') {
			arr[x] = arr[x].toString();
		}
	}
	arr.push(ENCRYPT_TOKEN);
	//按字母序排列
	arr.sort();
	var tmpStr = arr.join('');
	//生成签名，需引入md5.min.js
	var signature	= md5(tmpStr);
	return signature;
}

/*
 * 设置导航栏背景色
 */
function plumSetNavBarStyle(dom_id, color) {
	document.getElementById(dom_id).style.backgroundColor=color;
}

/*
 * 设置默认占位图片
 */
function plumImageLoadErr(obj, type) {
	$(obj).attr('src', PLACEHOLDER[type]);
}
/*
 * 设置当前区域
 */
function plumSetRegion(info) {
	for (var x in LOCATION_KEY) {
		var value	= (LOCATION_KEY[x] in info) && info[LOCATION_KEY[x]] ? info[LOCATION_KEY[x]] : null;
		$api.setStorage(LOCATION_KEY[x], value);
	}
}
/*
 * 获取区域
 */
function plumGetRegion() {
	var ret = {};
	for (var x in LOCATION_KEY) {
		ret[LOCATION_KEY[x]]		= $api.getStorage(LOCATION_KEY[x]);
	}
	return ret;
}

/**
 * 扫码情况
 * @param {Object} obj
 */
function scanner(){
	var FNScanner = api.require('FNScanner');
	FNScanner.openScanner({
	    autorotation: true
	}, function(ret, err){        
	    if( ret ){
	    	var type = ret.eventType;
	        if(type == 'success'){
	        	var content = ret.content;
	        	if(content.length == 8){
	        		
					var extra = {
				  		'code' : content,
				  	};
//					plumOpenCommonWin('shop-detail', '', extra);
        		}else{
        			alert('未找到店铺！');
        		}
	        }
	    }else{
	        alert( JSON.stringify( err ) );
	    }
	});
}

function shopMember(id){
	var url = 'map=api_member_follow_shop';
	var data = {
		'id' 	: id
	};
	plumAjax(url, data, function(ret) {
		if (ret.ec == 200) {
			alert(ret.data.msg);
		}
	}, function() {
		
	}, function() {
		plumNetworkFail(false);
	});
}

/*
 * 生成签名
 */
function checkCode(mobile, key,timestamp,signature) {
	var  new_signa = plumEncryptCheck([mobile, key, timestamp]);
	var result = {
		'status' : false,
		'error'	 : '验证码错误',
		'sign'   : ''
	};
	if(new_signa === signature){
		result = {
			'status' : true,
			'error'	 : '验证码正确',
			'sign'   : new_signa,
		};
	}
	return result;
}

function plum_msg_show(msg){
	api.toast({
		msg : msg,
		location : 'bottom'
	});
}
/*
 * 修复顶部状态栏高度适配
 */
function plumFixStatusBar(dom) {
 	dom.style.paddingTop = api.safeArea.top + 'px';
}

function closeWin(){
    api.closeWin();
} 

/**
 *打开地图 
 * @param {Object} obj
 */
function openMap(obj){
    var shopName = $(obj).data('name');
    var addr     = $(obj).data('addr');
    var city     = $(obj).data('city');
    //plumNeedLogin('i-map',shopName,{addr:addr});
    plumOpenCommonWin('i-map',shopName,{addr:addr,name:shopName,city:city});
}

