function openSlide(obj){
	var type = $(obj).data('type');
	var skip = $(obj).data('skip');
}
function openShopList(obj) {
	var extra = {
	  		'kind' : $(obj).data('id')
	  	}
	plumOpenCommonWin('shop-list', '店铺列表', extra);
}
function openShopDetail(obj) {
	//name = typeof name == "undefined" ? false : name; 
	var id = $(obj).data('id');
	if(id){
		var timestamp = new Date().getTime();
		var extra = {
		  		'id' : id,
		  		'useWinName' : timestamp+id
		  	};
		plumOpenCommonWin('shop-detail', '店铺详情', extra);
	}
}

function openProductDetail(obj) {
	var id = $(obj).data('id');
	if(id){
		var timestamp=new Date().getTime();
		var extra = {
			'id' : id,
	  		'useWinName' : timestamp+id,
	  		'right' : {
	  			'icon'  : 'share-btn.png',
	  			'extra' : '',
	  			'eventName' :'toshare',
	  		}
		};
		plumOpenCommonWin('product-detail', '商品详情', extra);
	}
}

function openProductList(obj) {
	var id = "id" in api.pageParam['extra'] ? api.pageParam['extra'].id : 0;
	var extra = {
		'shop' : id
	}
	plumOpenCommonWin('product-list', '商品列表',extra);
}
/**
 * 打电话
 * @param {Object} obj
 */
function openDial(obj) {
	api.call({
		type : 'tel_prompt',
		number : $(obj).data('tel')
	});
}

function openTencent(obj){
	var  qq = $(obj).data('qq');
	if(qq){
		var url = 'mqqwpa://im/chat?chat_type=wpa&uin='+qq+'&version=1&src_type=web&web_src=oicqzone.com';
		window.open(url);
	}else{
		api.toast({
			msg : '尚未添加客服',
			location : 'bottom'
		});
	}
}

function openGoodsDetail(obj) {
	var id = $(obj).data('id');
	var integral = $(obj).data('integral');
	var timestamp=new Date().getTime();
	var extra = {
		'id' : id,
		'integral' : integral,
  		'useWinName' : timestamp+id,
//		'right' : {
//			'icon'  : 'share-btn.png',
//			'extra' : '',
//			'eventName' :'toshare',
//		}
	};		
    plumOpenCommonWin('goods-detail', '商品详情', extra);				
}

/**
 * 收藏店铺或商品
 * @param {Object} obj
 */
function collect(obj){
	var user = plumGetUser();
	if(user.plum_user){
		var id 	 = $(obj).data('id');
		var type = $(obj).data('type');
		if(id){
			var url = 'map=api_collect_add';
			var data = {
				'id' : id,
				'type'	: type
			};
			plumAjax(url, data, function(ret) {
				if (ret.ec == 200) {
					api.toast({
						msg : ret.data.msg,
						location : 'bottom'
					});
					//发广播，更新收藏
					api.sendEvent({
							name : 'user-oper-eventr'
						});
					$(obj).html('已收藏');
					$(obj).removeAttr('onclick');
				} else {
					api.toast({
						msg : ret.em,
						location : 'bottom'
					});
				}
			}, function() {
				//api.hideProgress();
			}, function() {
				plumNetworkFail(false);
			});
		}
	}else{
		plumOpenCommonWin('login', '登录', {});
	}
	
}

function deleteItem(obj){
	var id   = $(obj).data('id');
	var type = $(obj).data('type');
	if(id && type){
		var url = '',key=0;
		switch(type){
			case 'colshop':
				 url = 'map=api_collect_delete';
				 key = 1;
				break;
			case 'colgoods':
				 url = 'map=api_collect_delete';
				 key = 2;
				break;
			case 'address':
				 url = 'map=api_address_delete';
				break;
		} 
		if(url){
			var data = {
				'id' 	: id,
				'type'	: key
			};
			plumAjax(url, data, function(ret) {
				if (ret.ec == 200) {
					api.toast({
						msg : ret.data.msg,
						location : 'bottom'
					});
					$(obj).parent().hide();
				} else {
					api.toast({
						msg : ret.em,
						location : 'bottom'
					});
				}
			}, function() {
				//api.hideProgress();
			}, function() {
				plumNetworkFail(false);
			});
		}
	}
}
function fetchCollectNum(){
    	var url = 'map=api_collect_count';
    	var data = {};
		plumAjax(url, data, function(ret) {
			if (ret.ec == 200) {
				$('#colgoods').html( ret.data.col_goods);
       			$('#colshop').html( ret.data.col_shop);
				api.parseTapmode();
			} else {
//				api.toast({
//					msg : ret.em,
//					location : 'bottom'
//				});
			}
		}, function() {
			//关闭刷新状态，关闭进度提示
		}, function() {
			plumNetworkFail(false);
		});
    }
function showTplData(contentID,tplID,data){
	var content = $('#'+contentID);
	var tpl = $('#'+tplID).text();
	var tempFn = doT.template(tpl);
	content.append(tempFn(data));
}
/****
 * 幻灯点击事件
 * type 1无连接，2商铺，3商品，4外链
 * skip：是类型对应的value值
 * @param {Object} obj
 */
function openSlide(obj) {
	var type = parseInt($(obj).data('type'));
	var skip = $(obj).data('skip');
	var name = $(obj).data('title');
	switch(type) {
		case 2 :
			plumOpenCommonWin('shop-detail', name, {'id' : skip});
			break;
		case 3 :
			plumOpenCommonWin('product-detail', name, {'id' : skip});
			break;
		case 4 : 
			plumOpenHeader('custom', 'web', name, {'url' : skip});
			break;
	}
}

function openGoodsList(obj){
	var data = $(obj).data();
	var title = data.title ? data.title : '商品列表';
	plumOpenCommonWin('goods-list', title, data);
}


