var timestamp=0,signature='';
apiready = function() {
	api.parseTapmode();
};
var wait=60, disabled=false;
function time(o) {
    if (wait == 0) {
        $("#"+o.id).on('click',function(){
          time(this);
        });
        $("#"+o.id).removeAttr('disabled');
        $("#"+o.id).css('background-color','#39C166')
        $("#"+o.id).val('获取验证码');
    	wait = 60;
    } else {
        $("#"+o.id).attr('disabled','true')
        $("#"+o.id).css('background-color','#B6B6B6')
        $("#"+o.id).val( wait + "s");
        wait--;
        setTimeout(function() {
            time(o)
        }, 1000)
    }
}

function fetchCode(obj){
	if (disabled) {
		return;
	}
	var phone = $('#phone').val();
	if (!plumIsPhone(phone)) {
		api.alert({
			title: '提示',
			msg : '手机号格式不正确'
        });
        return;
	}
	disabled = true;
	var url = "map=api_user_sendCode";
	var data = {mobile: phone};
	plumAjax(url, data, function(ret) {
		if (ret.ec == 200) {
			timestamp = ret.data.timestamp;
			signature = ret.data.signature;
			api.toast({
				msg : '验证码已发送',
				location : 'bottom'
			});
			time(obj);		
		} else {
			api.alert({
				title: '发送结果',
				msg : ret.em
	        });
		}
	}, function() {
		
	}, function() {
		plumNetworkFail(false);
	});
}

function registerBtn() {
	var phone = $('#phone').val();
	var code  = $('#code').val();
	var pass  = $('#password').val();
	var conf  = $('#confirmPWD').val();
	var check = true;
	var msg = '';
	if (!plumIsPhone(phone)) {
		check = false;
		msg = '手机格式不正确';
	}
	
	if (!plumIsCode(code)) {
		check = false;
		msg = '请输入数字验证码';
	}

	if (!plumPassCheck(pass)) {
		check = false;
		msg = '密码长度介于6-30之间';
		
	}
	if (pass != conf) {
		check = false;
		msg = '密码不一致';
	}
	var check_sign = checkCode(phone, code, timestamp,signature);
	if(!check_sign.status){
		check = false;
		msg = check_sign.error;
	}
	if(check){
		register(phone,code,pass,check_sign.sign);
	}else{
		api.alert({
			title: '错误提示',
			msg : msg
		});
	}
	
}
function register(phone,code,pass,sign){
	var invite = $('#invite').val();
	//显示进度提示
	api.showProgress({
		style : 'default',
		animationType : 'fade',
		title : '提交中',
		text : '请稍候',
		modal : true
	});
	var url = "map=api_user_new_register";
	var data = {
		'mobile' : phone,
		'code'   : code,
		'pwd'    : pass,
		'timestamp' : timestamp,
		'signature' : signature
	};
	plumAjax(url, data, function(ret) {
		if (ret.ec == 200) {
			var temp = ret.data;
			plumSetUser({
				'plum_session' 	:  temp.plum_session_api,
				'plum_nickname'	:  temp.nickname,
				'plum_avatar'	:  temp.avatar,
				'plum_mobile'	:  phone,
			});
			api.sendEvent({
                name:'user_login',
            });
			api.alert({
				title : '成功',
				msg : temp.msg
			}, function(ret, err) {
				api.closeToWin({
					name : 'root',
					animation : {
						type : 'flip',
						subType : 'from_bottom',
						duration : 500
					}
				});
			});
		} else {
			api.toast({
				msg : ret.em,
				location : 'bottom'
			});
		}
	}, function() {
		//关闭进度提示
		api.hideProgress();
	}, function() {
		plumNetworkFail(false);
	});

}

